/*Copyright (C) 2010 Deveaux Duncan

This file is part of Hikou no mizu.

Hikou no mizu is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Hikou no mizu is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Hikou no mizu.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "ImageManager.hpp"

ImageManager *ImageManager::singletonObject = 0;

ImageManager::ImageManager()
{
    
}

ImageManager *ImageManager::getInstance()
{
    if (!singletonObject)
        singletonObject = new ImageManager();
    
    return singletonObject;
}

sf::Image *ImageManager::getImage(const std::string &imagePath)
{
    if (!isImageLoaded(imagePath))
        loadImage(imagePath);
    
    return &m_imagesList[imagePath];
}

void ImageManager::loadImage(const std::string &imagePath)
{   
    sf::Image loadedImage;
    loadedImage.LoadFromFile(imagePath);
    loadedImage.SetSmooth(false);
    
    m_imagesList[imagePath] = loadedImage;
}

bool ImageManager::isImageLoaded(const std::string &imagePath)
{
    std::map<std::string, sf::Image>::iterator it;
    it = m_imagesList.find(imagePath);
    
    if (it != m_imagesList.end())
        return true;
    
    return false;
}